var before = 0;
var after = 0;
apiready = function () {
    mypomelo = api.require('mypomelo');
    vue = new Vue({
        el: '#main',
        mixins: [mixin],
        data: {
            deleTimer:null,
            deleClick:false,
            deleItem:null,
            pageShareType: 'index_wzxq',
            showTabBar: true,
            tabActive: 2,
            currentBannerId: 0,
            qipuList: [],
            pageIndex: 1,
            loading: true,
            finished: false,
            isLoading: false,
            indexTab: true, //右下角圆圈
            beforeTop: 0,
            afterTop: 0,
            target: '',
            loadEnd: false,
            qipanLoading: true,
            nowDays: {
                year: '',
                month: '',
                day: ''
            },
            topTab: [
                { text: '纯人评测', class: 'gra_blue', icon: 'iconduizhanpingtai', url: 'play_chess/qlcp' },
                { text: '好友对战', class: 'gra_orange', icon: 'iconhaoyouduizhan', url: 'play_chess/create_room' },
                { text: 'AI博弈', class: 'gra_purple', icon: 'iconai1', url: 'play_chess/ai' },
                { text: '棋社', class: 'gra_blue', icon: 'iconshequ4', url: 'play_chess/association' },
                { text: '人机对战', class: 'gra_purple', icon: 'iconjiqiren1', url: 'chess/ai' },
                { text: '复盘拆解', class: 'gra_green', icon: 'iconcaidanlanfupanlanse', url: 'chess/analyse' },
                { text: '排行榜', class: 'gra_blue', icon: 'iconpaihangbang1', url: 'play_chess/rank_list' },
                { text: '我的棋谱', class: 'gra_red', icon: 'iconwenkuguanli', url: 'frame/frame4' },
            ],
            bannerList: [],
            connected: false, //监控ws是否已经连接成功
            mySwiper: '',
            newMessage: 0,
            newUpdate: {
                show: false,
                text: '王者象棋最新版来啦，马上更新体验吧！',
                showClose: true,
                showProgress: false,
                percentAge: 0,
                type: 1
            },
            updateSource: '',
            winWidth: 0
        },
        created: function () {
            if (!this.hideInfo) this.init3DTouch();
            this.getUserInfo();
            this.initPushData();
            this.initData();
            this.checkUpdate();
            this.initMessage();
            this.listen();
            this.init();
            this.getData();
            this.initDays();
            this.getLessonBuy();
            document.getElementById('loading').innerText = '';
            localStorage.setItem('appIconBardge', 0);
        },
        mounted: function () {
            api.setStatusBarStyle({
                style: 'dark',
                color: 'rgba(0,0,0,0)'
            });
        },
        methods: {
            listen: function () {
                var vm = this;
                api.addEventListener({
                    name: 'initPlayData'
                }, function (ret, err) {
                    if (ret) {
                        vm.initData();
                    }
                });
                api.addEventListener({
                    name: 'refreshQipu'
                }, function (ret, err) {
                    if (ret) {
                        vm.onRefresh();
                    }
                });
                api.addEventListener({
                    name: 'refreshMessage'
                }, function (ret, err) {
                    if (ret) {
                        vm.initMessage();
                    }
                });
            },
            getData: function () {
                this.ajaxPost(xqwxt_url + "&do=common&op=getChessBanner", {}, function (vm, ret) {
                    vm.bannerList = ret.data.banner;
                    vm.topTab = ret.data.topTab;
                    setTimeout(function () {
                        if (vm.mySwiper) {
                            vm.mySwiper.update()
                        } else {
                            vm.mySwiper = new Swiper('.my-swipe', {
                                loop: true,
                                autoplay: {
                                    delay: 2500,
                                    disableOnInteraction: false,//用户操作swiper之后是否禁止自动切换
                                },
                                pagination: {
                                    el: '.swiper-pagination',
                                }
                            })
                        }
                    }, 100)
                })
            },
            clickBanner: function (item) {
                if (!item) return;
                if (item.type == 'window') {
                    this.openPage(item.path, item.params);
                } else {
                    var browser = api.require('webBrowser');
                    if (item.path.indexOf('?') == -1) {
                        browser.open({
                            url: item.path + '?appuid=' + this.memberinfo.uid
                        });
                    } else {
                        browser.open({
                            url: item.path + '&appuid=' + this.memberinfo.uid
                        });
                    }

                }
            },
            onChange: function (index) {
                this.currentBannerId = index;
            },
            onRefresh: function () {
                var _this = this;
                this.pageIndex = 1;
                this.finished = false;
                this.getData();
                this.initMessage();
                this.getUserInfo();
                setTimeout(function () {
                    _this.getList(1);
                }, 300);
            },
            getList: function (type) {
                var _this = this;
                mySendMessage(mysetting.routes.getChesses, {
                    page: _this.pageIndex,
                    psize: 10,
                    isNew: 1
                }, function (ret) {
                    if (ret.errno == 0) {
                        if (_this.pageIndex == 1) {
                            _this.qipuList = [];
                        }
                        for (var i = 0; i < ret.data.length; i++) {
                            ret.data[i].result={
                                'win':0,
                                'lose':0,
                                'draw':0
                            }
                            for (var j = 0; j < ret.data[i].day.length; j++) {
                                if((ret.data[i]['day'][j]['result']==1 && ret.data[i]['day'][j]['reduid']==uid) || (ret.data[i]['day'][j]['result']==2 && ret.data[i]['day'][j]['reduid'] != uid )  ){
                                    ret.data[i].result['win']++
                                }else if( (ret.data[i]['day'][j]['result']==2 && ret.data[i]['day'][j]['reduid']==uid ) || (ret.data[i]['day'][j]['result']==1 && ret.data[i]['day'][j]['reduid'] != uid )  ){
                                    ret.data[i].result['lose']++
                                }else if(ret.data[i]['day'][j]['result']==3){
                                    ret.data[i].result['draw']++
                                }
                                var tempItem = ret.data[i].day[j];
                                if (tempItem.reduid == uid) {
                                    initialization(_this.target, 'tempCanvas' + '', board2map(tempItem.fen, 1));
                                } else {
                                    initialization(_this.target, 'tempCanvas' + '', arrReverse(board2map(tempItem.fen, 1)), 0, 1);
                                }
                                _this.$refs['tempCanvas'].width = 72 * 5;
                                _this.$refs['tempCanvas'].height = 83 * 5;
                                stage2.scaleX = stage2.scaleY = 0.5;
                                stage2.update();
                                ret.data[i].day[j].src = stage2.toDataURL();
                            }
                            if((i+1) == ret.data.length  && typeof ret.data[i].strengthPlus === "undefined"  ){
                                ret.data[i].strengthPlus=ret.data[i].strength-1500
                            }
                            if (_this.qipuList.length != 0 && _this.qipuList[_this.qipuList.length - 1].days == ret.data[i].days) {
                                for (var k = 0; k < ret.data[i].day.length; k++) {
                                    _this.qipuList[_this.qipuList.length - 1].day.push(ret.data[i].day[k])
                                }
                                _this.qipuList[_this.qipuList.length - 1]['result']['win'] += ret.data[i].result['win']
                                _this.qipuList[_this.qipuList.length - 1]['result']['lose'] += ret.data[i].result['lose']
                                _this.qipuList[_this.qipuList.length - 1]['result']['draw'] += ret.data[i].result['draw']
                              //  _this.qipuList[_this.qipuList.length - 1].strengthPlus +=  ret.data[i].strength
                            } else {
                                _this.qipuList.length > 0 ? _this.qipuList[_this.qipuList.length - 1].strengthPlus = _this.qipuList[_this.qipuList.length - 1].strength - ret.data[i].strength : '';
                                _this.qipuList.push(ret.data[i]);
                            }
                        }
                        _this.loading = false;
                        _this.isLoading = false;
                        _this.finished = false;
                        _this.pageIndex++;
                    } else {
                        _this.loading = false;
                        _this.isLoading = false;
                        _this.finished = true;
                    }
                })

            },
            getResultStr(result){
                let msg=''
                if(result['win']){
                    msg = result['win']+"胜"
                }
                if(result['lose']){
                    msg += (result['win']?"/":"") + result['lose']+"负"
                }
                if(result['draw']){
                    msg += (result['lose']?"/":"") + result['draw']+"和"
                }
                return msg
            },
            touchDele:function(e,item){
                // e.preventDefault();
                 let _this=this
                 _this.deleItem=item
                 _this.deleClick = false 
                  _this.deleTimer = setTimeout(function(){
                 _this.deleClick=true
                 _this.$dialog.confirm({
                     title: '删除棋谱',
                     message: '确认删除棋谱吗？',
                     closeOnClickOverlay:true
                 }).then(function() {
              
                     _this.ajaxPost(xqwxt_url+'&op=delete_index_chess&do=chess', { chessid: _this.deleItem.id }, function(vm,data) {
                        // data = $.parseJSON(data);
                         console.log(data.message,123456);
                         vm.$toast({
                             message: data.message,
                         })
                         setTimeout(function(){
                             _this.pageIndex = 1;
                             _this.getList(1);
                         },1000)
                     });
                 }).catch(() => {
                    // on cancel
                    console.log('取消')
                  });
                  },500)
                 return false
             },
             touchDeleMove(){
                 clearTimeout(this.deleTimer)
                 this.deleClick=true
                 
             },
             touchDeleEnd(){
             
                 clearTimeout(this.deleTimer)
                 if(!this.deleClick){
                     this.openPage('chess/chess', {role: (this.deleItem.reduid==this.uid?1:2), chessid: this.deleItem.id })
                 }
                 
             },
            initDays: function () {
                var now = new Date();
                this.nowDays.year = now.getFullYear();
                this.nowDays.month = now.getMonth() + 1;
                this.nowDays.day = now.getDate();
            },
            handleScroll: function (e) {
                this.afterTop = e.target.documentElement.scrollTop || e.target.body.scrollTop;
                if (this.afterTop <= this.beforeTop) {
                    this.indexTab = true;
                    this.beforeTop = this.afterTop;
                } else {
                    this.indexTab = false;
                    this.beforeTop = this.afterTop;
                }
            },
            init: function () {
                var loader = new createjs.LoadQueue(false, null, "");
                loader.on("fileload", this.handleFileLoad);
                loader.on("complete", this.handleComplete);
                loader.loadFile({ src: "../../script/util/ZobristTable.js" });
                loader.loadFile({ src: "../../script/lib/easeljs.min.js", id: 'Easeljs' });
                loader.loadFile({ src: "../../script/lib/tweenjs.min.js" });
                loader.loadFile({ src: "../../script/Model.js" });
                loader.loadFile({ src: "../../script/View.js" });
                loader.loadFile({ src: "../../script/Control.js" });
                loader.loadFile({ src: "../../script/Player.js" });
                loader.loadFile({ src: "../../script/Chess.js" });
                loader.loadFile({ src: "../../script/lib/gameRes.js" });
                loader.loadManifest([
                    { src: "../../assets/images/board.png", id: "Board", loadTimeout: 20000 },
                    { src: "../../assets/images/border1.png", id: "Border1", loadTimeout: 20000 },
                    { src: "../../assets/images/border2.png", id: "Border2", loadTimeout: 20000 },
                    { src: "../../assets/images/vertical1.png", id: "Vertical1", loadTimeout: 20000 },
                    { src: "../../assets/images/vertical2.png", id: "Vertical2", loadTimeout: 20000 }
                ]);
            }, //初始化加载资源
            handleFileLoad: function (evt) {
                if (evt.item.type == "image") {
                    images[evt.item.id] = evt.result;
                }
                if (evt.item.id == 'Easeljs') {
                    chessList = new createjs.SpriteSheet(CHESS_SLIM);
                    effectList = new createjs.SpriteSheet(F_ATLAS);
                }
            },
            handleComplete: function (evt) {
                if (chessList.complete && effectList.complete) {
                    this.target = evt;
                    this.loadEnd = true;
                    this.qipanLoading = false;
                    this.getList();
                } else {
                    chessList.addEventListener("complete", function () {
                        vue.handleComplete();
                    });
                    effectList.addEventListener("complete", function () {
                        vue.handleComplete();
                    });
                }
            },
            initData: function (path, params) {
                isOpened = false;
                mySendMessage(mysetting.routes.getPlayData, {}, function (data) {
                    if (data.errno == 0 && data.data.playData) {
                        closeWinList(data.data.roomType);
                        goToPage(data.data.roomType);
                    } else {
                        closeWinList();
                        if (path) {
                            if (path == 'root/study') {
                                var jsfun = 'vue.tabActive=3;vue.openFrame(3)';
                                api.execScript({
                                    name: 'root',
                                    script: jsfun
                                });
                            } else {
                                vue.openPage(path, params);
                            }
                        }
                    }
                });
            },
            init3DTouch: function () {
                var _this = this;
                if (api.systemType == 'ios') {
                    var threeTouch = api.require('3DTouch');
                    threeTouch.setListener(
                        function (ret, err) {
                            var type = ret.type;
                            _this.initData(type);
                        }
                    );
                }
            },
            initPushData: function () {
                var _this = this;
                // var pushApi = api.require('mobPushPlus');
                // pushApi.addpushReceiver(function (ret, err) {
                //     if (ret && ret.result) {
                //         if (ret.action == 1) {
                //             _this.initMessage();
                //         }
                //         if (ret.action == 2) {
                //             var extra = ret.result.extra;
                //             if (extra && extra.type == 'window') {
                //                 _this.initData(extra.path, JSON.parse(extra.params));
                //             } else if (extra && extra.type == 'link') {
                //                 var browser = api.require('webBrowser');
                //                 if (extra.path.indexOf('?') == -1) {
                //                     browser.open({
                //                         url: extra.path + '?appuid=' + this.memberinfo.uid
                //                     });
                //                 } else {
                //                     browser.open({
                //                         url: extra.path + '&appuid=' + this.memberinfo.uid
                //                     });
                //                 }
                //             }
                //         }
                //     }
                // });
            },
            updateApp: function () {
                var _this = this;
                if (api.systemType == "android") {

                    var smarket = api.require('marketScore');
                            smarket.myScore({
                            appname: 'com.zzyj.king'
                        });
                        
                    return false

                    this.setPermission(function (param) {
                        if (param) {
                            api.download({
                                url: _this.updateSource,
                                report: true
                            }, function (ret, err) {
                                if (ret && 0 == ret.state) {/* 下载进度 */
                                    _this.newUpdate.showProgress = true;
                                    _this.$set(_this.newUpdate, 'percentAge', parseInt(ret.percent))
                                }
                                if (ret && 1 == ret.state) {/* 下载完成 */
                                    _this.newUpdate.show = false;
                                    api.execScript({
                                        name: 'root',
                                        script: 'vue.showP=false;'
                                    });
                                    var savePath = ret.savePath;
                                    api.installApp({
                                        appUri: savePath
                                    });
                                }
                            });
                        } else {
                            _this.$toast('无法获得存储权限，请在设置中打开应用的存储权限');
                        }
                    });
                }
                if (api.systemType == "ios") {
                    api.installApp({
                        appUri: _this.updateSource
                    });
                }
            },
            closeUpdate: function () {
                this.newUpdate.show = false;
                api.execScript({
                    name: 'root',
                    script: 'vue.showP=false;'
                });
                localStorage.setItem('notAsk', new Date().getTime());
            },
            checkUpdate: function () {
                var _this = this;
                var mam = api.require('mam');
                if ( !localStorage.getItem('notAsk') || ((new Date().getTime() - localStorage.getItem('notAsk')) > 60 * 60 * 1000 * 24 * 1)) {
                    mam.checkUpdate(function (ret, err) {
                        console.log(JSON.stringify(ret))
                        if (ret && ret.result) {
                            var result = ret.result;
                            if (result.update == true && result.closed == false) {
                                _this.newUpdate.show = true;
                                _this.newUpdate.text = '新版本：' + result.version + '<br>更新内容：<br>' + result.updateTip;
                                _this.updateSource = result.source;
                                api.execScript({
                                    name: 'root',
                                    script: 'if(vue.tabActive==0) vue.showP=true;'
                                });
                            } else if (result.update == true && result.closed == true) {
                                _this.newUpdate.show = true;
                                _this.newUpdate.showClose = false;
                                _this.newUpdate.text = '当前APP版本已无法使用，请立即更新！<br>新版本：' + result.version + '<br>更新内容：<br>' + result.updateTip;
                                _this.updateSource = result.source;
                                api.execScript({
                                    name: 'root',
                                    script: 'if(vue.tabActive==0) vue.showP=true;'
                                });
                            }
                        }
                    });
                }
                mam.checkSmartUpdate(function (ret, err) {
                    if (ret) {
                        mam.startSmartUpdate(function (ret, err) { });
                    }
                });
            },
            getLessonBuy: function () {
                this.ajaxPost(xqwxt_url + '&do=mylesson&op=myplaylesson', {}, function (vm, ret) {
                    localStorage.setItem('lessonListBuy', JSON.stringify(ret.data));
                })
            },
            initMessage: function () {
                mySendMessage(mysetting.routes.getMessageNums, {}, function (data) {
                    if (data.errno == 0) {
                        vue.newMessage = data.data.nums;
                        api.setAppIconBadge({
                            badge: data.data.nums
                        });
                    }
                });
            },
        },
    });
}
function closeWinList(roomType) {
    var name = '';
    if (roomType == 'qlcp') name = 'play_chess/qlcp';
    if (roomType == 'hydz' || roomType == 'QS') name = 'play_chess/create_room';
    if (roomType == 'AI') name = 'play_chess/ai_test';
    var winList = api.windows();
    for (var i = 0; i < winList.length; i++) {
        if (winList[i].name == 'play_chess/qlcp' || winList[i].name == 'play_chess/ai_test' || winList[i].name == 'play_chess/create_room') {
            if (roomType) {
                if (winList[i].name == name) {
                    isOpened = true;
                    api.execScript({
                        name: winList[i].name,
                        frameName: winList[i].name,
                        script: 'vue.getPlayData();'
                    });
                } else {
                    vue.closePage(winList[i].name, 1);
                }
            } else {
                api.execScript({
                    name: winList[i].name,
                    frameName: winList[i].name,
                    script: 'vue.rebackHall();'
                });
            }
        } else if (winList[i].name == 'play_chess/association_detail') {
            api.execScript({
                name: winList[i].name,
                frameName: winList[i].name,
                script: 'location.reload()'
            });
        } else if (winList[i].name == 'chess/analyse') {
            api.execScript({
                name: winList[i].name,
                frameName: winList[i].name,
                script: 'sendMessage()'
            });
        }
    }
}
function goToPage(roomType) {
    setTimeout(function () {
        if (!isOpened) {
            var name = '';
            if (roomType == 'qlcp') name = 'play_chess/qlcp';
            if (roomType == 'hydz' || roomType == 'QS') name = 'play_chess/create_room';
            if (roomType == 'AI') name = 'play_chess/ai_test';
            vue.openPage(name, { showLoading: true });
        }
    }, 100);
}